VERSION 5.00
Begin VB.UserControl MMZ_X_Btn_T 
   AutoRedraw      =   -1  'True
   CanGetFocus     =   0   'False
   ClientHeight    =   1140
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   2145
   DefaultCancel   =   -1  'True
   KeyPreview      =   -1  'True
   ScaleHeight     =   76
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   143
   ToolboxBitmap   =   "XPButton_T.ctx":0000
   Begin VB.Timer Timer1 
      Enabled         =   0   'False
      Interval        =   1
      Left            =   480
      Top             =   600
   End
   Begin VB.Shape Shape1 
      Height          =   495
      Left            =   120
      Top             =   120
      Width           =   1215
   End
End
Attribute VB_Name = "MMZ_X_Btn_T"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

Private Enum ColorStyle
    mjDisabled = 0
    mjNormal = 1
    mjMove = 2
    mjFocus = 3
End Enum
Private Type RECT
    Left As Long
    Top As Long
    Right As Long
    Bottom As Long
End Type
Private Type POINTAPI
    X As Long
    Y As Long
End Type
Private Type GRADIENT_RECT
    UpperLeft As Long
    LowerRight As Long
End Type
Private Type TRIVERTEX
    X As Long
    Y As Long
    Red As Integer
    Green As Integer
    Blue As Integer
    Alpha As Integer
End Type

Private Declare Function GetCursorPos Lib "user32" (lpPoint As POINTAPI) As Long
Private Declare Function SetCursorPos Lib "user32" (ByVal X As Long, ByVal Y As Long) As Long
Private Declare Function GetWindowRect Lib "user32" (ByVal hWnd As Long, lpRect As RECT) As Long
Private Declare Function SetCapture Lib "user32" (ByVal hWnd As Long) As Long
Private Declare Function GetPixel Lib "gdi32" (ByVal hDC As Long, ByVal X As Long, ByVal Y As Long) As Long
Private Declare Function DrawFocusRect Lib "user32" (ByVal hDC As Long, lpRect As RECT) As Long
Private Declare Function GradientFillRect Lib "msimg32" Alias "GradientFill" (ByVal hDC As Long, pVertex As TRIVERTEX, ByVal dwNumVertex As Long, pMesh As GRADIENT_RECT, ByVal dwNumMesh As Long, ByVal dwMode As Long) As Long

Dim m_Alignment As AlignmentConstants
Dim m_Caption As String
Dim PicPos1 As POINTAPI
Dim MDN As Boolean, MDN2 As Boolean, Working As Boolean
Dim HasFocus As Boolean, SpcDn As Boolean, RS As Boolean
Dim Init As Boolean, CanHighLight As Boolean
Dim LastButton As Integer
Private LastColorType As ColorStyle, LastPushed As Boolean

Event Click()
Event MouseMove()
'Default Property Values:
Const m_def_HaveBorder = True
Const m_def_HighLight = 16777215
Const m_def_FontSize = 0
Const m_def_StandardDisable = True
Const m_def_BackColor1 = 16777215
Const m_def_BackColor2 = 8388607
'Property Variables:
'Dim Shape1.Visible As Boolean
Dim m_HighLight As OLE_COLOR
Dim m_FontSize As Single
Dim m_StandardDisable As Boolean
Dim m_BackColor1 As OLE_COLOR
Dim m_BackColor2 As OLE_COLOR
Dim MB As Integer

Public Sub Refresh()
    CanHighLight = False
    PrintCaption
    DrawBorder mjNormal
    CanHighLight = True
End Sub

Private Sub DrawBorder(ColorType As ColorStyle, Optional Pushed As Boolean)
    Dim P1 As Long, P2 As Long, P3 As Long, P4 As Long, P5 As Long, P6 As Long
    Dim P7 As Long, P8 As Long
    On Error Resume Next
    If LastColorType = ColorType And LastPushed = Pushed And Not Working Then
        If Not RS Then Exit Sub
    Else
        RS = False
        LastColorType = ColorType
        LastPushed = Pushed
    End If
    If Init And Not Pushed And ColorType <> mjMove Then
        If Ambient.DisplayAsDefault Then
            ColorType = mjFocus
        End If
    End If
    If Not UserControl.Enabled Then
        ColorType = mjDisabled
        Pushed = False
    End If
    With UserControl
    .Cls
    If Not UserControl.Enabled And m_StandardDisable Then
        UserControl.BackColor = Ambient.BackColor
        P7 = GetPixel(UserControl.hDC, 0, 0)
        P8 = GetPixel(UserControl.hDC, 0, 0)
    ElseIf Pushed Then
        P7 = m_BackColor2
        P8 = m_BackColor1
    Else
        P7 = m_BackColor1
        P8 = m_BackColor2
    End If
    GradientFill .hDC, P7, P8, 0, 0, .ScaleWidth, .ScaleHeight, 1
    .Refresh
    End With
    If Not Working Then
        Working = True
        PrintCaption
        Working = False
    End If
End Sub

Private Function HasMouse() As Boolean
    Dim RECT As RECT, Point As POINTAPI
    GetWindowRect UserControl.hWnd, RECT
    GetCursorPos Point
    If Point.X < RECT.Left Or Point.X + 1 > RECT.Right Or Point.Y < RECT.Top Or Point.Y + 1 > RECT.Bottom Then
        HasMouse = False
    Else
        HasMouse = True
    End If
End Function

Private Sub CheckEnabled()
    If Enabled Then
        DrawBorder mjNormal
    Else
        DrawBorder mjDisabled
        Timer1 = False
    End If
End Sub

Private Sub PrintCaption()
    Dim a As String
    Dim Pos As Integer
    Dim FC As Long
    Dim X1 As Single, X2 As Single, Y As Single
    If Not Working Then
        Working = True
        RS = True
        DrawBorder LastColorType, LastPushed
        Working = False
    End If
    a = m_Caption
    Pos = InStr(a, "&")
    a = Replace(a, "&", "")
    With UserControl
    If Pos > 0 Then .AccessKeys = Mid(a, Pos, 1) Else .AccessKeys = ""
    If Not .RightToLeft Then
        If m_Alignment = vbCenter Then
            .CurrentX = (.ScaleWidth - .TextWidth(a)) \ 2
        ElseIf m_Alignment = vbLeftJustify Then
            .CurrentX = 5
        Else
            .CurrentX = .ScaleWidth - .TextWidth(a) - 5
        End If
    Else
        If m_Alignment = vbCenter Then
            .CurrentX = (.ScaleWidth - .TextWidth(a)) \ 2
        ElseIf m_Alignment = vbLeftJustify Then
            .CurrentX = .ScaleWidth - .TextWidth(a) - 5
        Else
            .CurrentX = 5
        End If
    End If
    .CurrentY = (.ScaleHeight - .TextHeight(a)) \ 2 + IIf((MDN And HasMouse) Or SpcDn, 1, 0)
    FC = .ForeColor
    If Not .Enabled And m_StandardDisable Then
        .ForeColor = &H80000011
    ElseIf HasMouse And CanHighLight And .Enabled Then
        .ForeColor = m_HighLight
    End If
    If Pos = 0 Or Pos = Len(m_Caption) Then
        UserControl.Print a
    Else
        UserControl.Print Left(a, Pos - 1);
        X1 = CurrentX
        Y = .CurrentY + .TextHeight(Mid(a, Pos, 1))
        X2 = .CurrentX + .TextWidth(Mid(a, Pos, 1))
        UserControl.Print Mid(a, Pos, 1);
        UserControl.Print Right(a, Len(a) - Pos)
        .Line 4, X1, Y, X2, Y, .ForeColor
    End If
    .ForeColor = FC
    End With
End Sub

Public Property Get Caption() As String
Attribute Caption.VB_Description = "Returns/sets the text displayed in an object's title bar or below an object's icon."
Attribute Caption.VB_UserMemId = -518
Attribute Caption.VB_MemberFlags = "200"
    Caption = m_Caption
End Property
Public Property Let Caption(ByVal New_Caption As String)
    m_Caption = New_Caption
    PrintCaption
    PropertyChanged "Caption"
End Property

Private Sub Timer1_Timer()
    If Not HasMouse Then
        If Not MDN Then
            If HasFocus Then
                DrawBorder mjFocus
            Else
                DrawBorder mjNormal
            End If
        End If
        Timer1.Enabled = False
    End If
End Sub

Public Property Get Enabled() As Boolean
Attribute Enabled.VB_Description = "Returns/sets a value that determines whether an object can respond to user-generated events."
    Enabled = UserControl.Enabled
End Property
Public Property Let Enabled(ByVal New_Enabled As Boolean)
    UserControl.Enabled() = New_Enabled
    CheckEnabled
    PrintCaption
    PropertyChanged "Enabled"
End Property

Public Property Get Font() As Font
Attribute Font.VB_Description = "Returns a Font object."
    Set Font = UserControl.Font
End Property
Public Property Set Font(ByVal New_Font As Font)
    Set UserControl.Font = New_Font
    PrintCaption
    PropertyChanged "Font"
End Property

Public Property Get MouseIcon() As Picture
Attribute MouseIcon.VB_Description = "Sets a custom mouse icon."
    Set MouseIcon = UserControl.MouseIcon
End Property
Public Property Set MouseIcon(ByVal New_MouseIcon As Picture)
    Set UserControl.MouseIcon = New_MouseIcon
    PropertyChanged "MouseIcon"
End Property

Public Property Get MousePointer() As MousePointerConstants
Attribute MousePointer.VB_Description = "Returns/sets the type of mouse pointer displayed when over part of an object."
    MousePointer = UserControl.MousePointer
End Property
Public Property Let MousePointer(ByVal New_MousePointer As MousePointerConstants)
    UserControl.MousePointer() = New_MousePointer
    PropertyChanged "MousePointer"
End Property

Public Property Get RightToLeft() As Boolean
Attribute RightToLeft.VB_Description = "Determines text display direction and control visual appearance on a bidirectional system."
    RightToLeft = UserControl.RightToLeft
End Property
Public Property Let RightToLeft(ByVal New_RightToLeft As Boolean)
    UserControl.RightToLeft = New_RightToLeft
    PrintCaption
    PropertyChanged "RightToLeft"
End Property

Public Property Get Alignment() As AlignmentConstants
    Alignment = m_Alignment
End Property
Public Property Let Alignment(ByVal New_Alignment As AlignmentConstants)
    m_Alignment = New_Alignment
    PrintCaption
    PropertyChanged "Alignment"
End Property

Public Property Get ForeColor() As OLE_COLOR
    ForeColor = UserControl.ForeColor
End Property
Public Property Let ForeColor(ByVal New_ForeColor As OLE_COLOR)
    UserControl.ForeColor = New_ForeColor
    PrintCaption
    PropertyChanged "ForeColor"
End Property

Private Sub UserControl_AccessKeyPress(KeyAscii As Integer)
    RaiseEvent Click
End Sub

Private Sub UserControl_AmbientChanged(PropertyName As String)
    RS = True
    If Ambient.DisplayAsDefault Then
        DrawBorder mjFocus
    Else
        If HasMouse Then
            DrawBorder mjMove
        Else
            DrawBorder mjNormal
        End If
    End If
End Sub

Private Sub UserControl_DblClick()
    If LastButton = 1 Then
        UserControl_MouseDown 1, 0, 0, 0
        SetCapture UserControl.hWnd
    End If
End Sub

Private Sub UserControl_EnterFocus()
    HasFocus = True
    If Not MDN Then
        If HasMouse Then
            DrawBorder mjMove
        Else
            DrawBorder mjFocus
        End If
    End If
End Sub

Private Sub UserControl_ExitFocus()
    HasFocus = False
    MDN = False
    SpcDn = False
    If HasMouse Then
        DrawBorder mjMove
    Else
        DrawBorder mjNormal
    End If
    PrintCaption
End Sub

Private Sub UserControl_Initialize()
    UserControl.Size 80 * 15, 33 * 15
    Init = True
End Sub

Private Sub UserControl_InitProperties()
    UserControl.RightToLeft = Ambient.RightToLeft
    m_Caption = Ambient.DisplayName
    Set UserControl.Font = Ambient.Font
    m_Alignment = vbCenter
    m_BackColor1 = m_def_BackColor1
    m_BackColor2 = m_def_BackColor2
    m_StandardDisable = m_def_StandardDisable
    m_FontSize = m_def_FontSize
    m_HighLight = m_def_HighLight
    Shape1.Visible = m_def_HaveBorder
End Sub

Private Sub UserControl_KeyDown(KeyCode As Integer, Shift As Integer)
    If KeyCode = vbKeySpace And Shift = 0 Then
        SpcDn = True
        If Not MDN Then
            DrawBorder mjNormal, True
        End If
    ElseIf KeyCode = vbKeyDown Or KeyCode = vbKeyRight Then
        SendKeys "{Tab}"
    ElseIf KeyCode = vbKeyUp Or KeyCode = vbKeyLeft Then
        SendKeys "+{Tab}"
    End If
End Sub

Private Sub UserControl_KeyPress(KeyAscii As Integer)
    If KeyAscii = 13 Then
        MDN = False
        SpcDn = False
        If HasMouse Then
            DrawBorder mjMove
        ElseIf HasFocus Then
            DrawBorder mjFocus
        Else
            DrawBorder mjNormal
        End If
        RaiseEvent Click
    ElseIf KeyAscii = 27 Then
        MDN = False
        SpcDn = False
        If HasMouse Then
            DrawBorder mjMove
        ElseIf HasFocus Then
            DrawBorder mjFocus
        Else
            DrawBorder mjNormal
        End If
    End If
End Sub

Private Sub UserControl_KeyUp(KeyCode As Integer, Shift As Integer)
    If KeyCode = vbKeySpace And SpcDn Then
        SpcDn = False
        If Not MDN Then
            If HasMouse Then
                DrawBorder mjMove
            ElseIf HasFocus Then
                DrawBorder mjFocus
            Else
                DrawBorder mjNormal
            End If
            RaiseEvent Click
        End If
    End If
End Sub

Private Sub UserControl_MouseDown(Button As Integer, Shift As Integer, X As Single, Y As Single)
    If MDN Then Exit Sub
    If Button = 1 Then
        SpcDn = False
        MDN = True
        MB = Button
        DrawBorder mjNormal, True
    End If
    LastButton = Button
End Sub

Private Sub UserControl_MouseMove(Button As Integer, Shift As Integer, X As Single, Y As Single)
    If SpcDn Then Exit Sub
    If HasMouse Then
        RaiseEvent MouseMove
        If MDN Then
            DrawBorder mjNormal, True
        Else
            DrawBorder mjMove
        End If
        Timer1 = True
    Else
        If MDN Then
            DrawBorder mjMove
        End If
    End If
End Sub

Private Sub UserControl_MouseUp(Button As Integer, Shift As Integer, X As Single, Y As Single)
    Dim IsMDN As Boolean
    If Button <> MB Then Exit Sub
    IsMDN = MDN
    MDN = False
    If SpcDn Then Exit Sub
    If HasFocus Then DrawBorder mjFocus Else DrawBorder mjNormal
    If Button = 1 And Shift = 0 And HasMouse And IsMDN Then RaiseEvent Click
End Sub

Private Sub UserControl_ReadProperties(PropBag As PropertyBag)
    m_Caption = PropBag.ReadProperty("Caption", "MMZ_X_Button")
    UserControl.Enabled = PropBag.ReadProperty("Enabled", True)
    Set MouseIcon = PropBag.ReadProperty("MouseIcon", Nothing)
    UserControl.MousePointer = PropBag.ReadProperty("MousePointer", 0)
    UserControl.RightToLeft = PropBag.ReadProperty("RightToLeft", False)
    m_Alignment = PropBag.ReadProperty("Alignment", vbCenter)
    UserControl.ForeColor = PropBag.ReadProperty("ForeColor", vbButtonText)
    Set UserControl.Font = PropBag.ReadProperty("Font", Ambient.Font)
    m_BackColor1 = PropBag.ReadProperty("BackColor1", m_def_BackColor1)
    m_BackColor2 = PropBag.ReadProperty("BackColor2", m_def_BackColor2)
    m_StandardDisable = PropBag.ReadProperty("StandardDisable", m_def_StandardDisable)
    m_FontSize = PropBag.ReadProperty("FontSize", m_def_FontSize)
    Shape1.BorderColor = PropBag.ReadProperty("BorderColor", -2147483640)
    m_HighLight = PropBag.ReadProperty("HighLight", m_def_HighLight)
    Shape1.Visible = PropBag.ReadProperty("HaveBorder", m_def_HaveBorder)
    CheckEnabled
    PrintCaption
End Sub

Private Sub UserControl_Resize()
    Shape1.Move 0, 0, UserControl.ScaleWidth, UserControl.ScaleHeight
    RS = True
    DrawBorder mjNormal
    CheckEnabled
End Sub

Private Sub UserControl_Show()
    CanHighLight = True
    If Ambient.DisplayAsDefault Then
        DrawBorder mjFocus
    Else
        If HasMouse Then
            DrawBorder mjMove
        Else
            DrawBorder mjNormal
        End If
    End If
End Sub

Private Sub UserControl_WriteProperties(PropBag As PropertyBag)
    Call PropBag.WriteProperty("Caption", m_Caption, "MMZ_X_Button")
    Call PropBag.WriteProperty("Enabled", UserControl.Enabled, True)
    Call PropBag.WriteProperty("Font", UserControl.Font, Ambient.Font)
    Call PropBag.WriteProperty("MouseIcon", MouseIcon, Nothing)
    Call PropBag.WriteProperty("MousePointer", UserControl.MousePointer, 0)
    Call PropBag.WriteProperty("Picture", Picture, Nothing)
    Call PropBag.WriteProperty("RightToLeft", UserControl.RightToLeft, False)
    Call PropBag.WriteProperty("Alignment", m_Alignment, vbCenter)
    Call PropBag.WriteProperty("ForeColor", UserControl.ForeColor, vbButtonText)
    Call PropBag.WriteProperty("BackColor1", m_BackColor1, m_def_BackColor1)
    Call PropBag.WriteProperty("BackColor2", m_BackColor2, m_def_BackColor2)
    Call PropBag.WriteProperty("StandardDisable", m_StandardDisable, m_def_StandardDisable)
    Call PropBag.WriteProperty("FontSize", m_FontSize, m_def_FontSize)
    Call PropBag.WriteProperty("BorderColor", Shape1.BorderColor, -2147483640)
    Call PropBag.WriteProperty("HighLight", m_HighLight, m_def_HighLight)
    Call PropBag.WriteProperty("HaveBorder", Shape1.Visible, m_def_HaveBorder)
End Sub
'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MemberInfo=10,0,0,0
Public Property Get BackColor1() As OLE_COLOR
    BackColor1 = m_BackColor1
End Property

Public Property Let BackColor1(ByVal New_BackColor1 As OLE_COLOR)
    m_BackColor1 = New_BackColor1
    PropertyChanged "BackColor1"
    Me.Refresh
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MemberInfo=10,0,0,0
Public Property Get BackColor2() As OLE_COLOR
    BackColor2 = m_BackColor2
End Property

Public Property Let BackColor2(ByVal New_BackColor2 As OLE_COLOR)
    m_BackColor2 = New_BackColor2
    PropertyChanged "BackColor2"
    Me.Refresh
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MemberInfo=0,0,0,0
Public Property Get StandardDisable() As Boolean
    StandardDisable = m_StandardDisable
End Property

Public Property Let StandardDisable(ByVal New_StandardDisable As Boolean)
    m_StandardDisable = New_StandardDisable
    PropertyChanged "StandardDisable"
    Me.Refresh
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MemberInfo=12,0,0,0
Public Property Get FontSize() As Single
Attribute FontSize.VB_MemberFlags = "400"
    FontSize = m_FontSize
End Property

Public Property Let FontSize(ByVal New_FontSize As Single)
    m_FontSize = New_FontSize
    UserControl.FontSize = New_FontSize
    PrintCaption
    PropertyChanged "FontSize"
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=Shape1,Shape1,-1,BorderColor
Public Property Get BorderColor() As OLE_COLOR
Attribute BorderColor.VB_Description = "Returns/sets the color of an object's border."
    BorderColor = Shape1.BorderColor
End Property

Public Property Let BorderColor(ByVal New_BorderColor As OLE_COLOR)
    Shape1.BorderColor() = New_BorderColor
    PropertyChanged "BorderColor"
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MemberInfo=10,0,0,0
Public Property Get HighLight() As OLE_COLOR
    HighLight = m_HighLight
End Property

Public Property Let HighLight(ByVal New_HighLight As OLE_COLOR)
    m_HighLight = New_HighLight
    PropertyChanged "HighLight"
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MemberInfo=0,0,0,0
Public Property Get HaveBorder() As Boolean
    HaveBorder = Shape1.Visible
End Property

Public Property Let HaveBorder(ByVal New_HaveBorder As Boolean)
    Shape1.Visible = New_HaveBorder
    PropertyChanged "HaveBorder"
End Property

'''''''''''''''''
Private Sub DecompRGB(ByVal C, r, G, B)
    B = C \ 65536
    G = (C Mod 65536) \ 256
    r = ((C Mod 65536) Mod 256)
End Sub

Private Function Synchronize(Color As Byte) As Integer
    If Color <= 127 Then
        Synchronize = 256 * Color
    Else
        Synchronize = (256 - Color) * -256
    End If
End Function

Private Sub GradientFill(hDC As Long, Color1 As Long, Color2 As Long, ByVal X1 As Long, ByVal Y1 As Long, ByVal X2 As Long, ByVal Y2 As Long, Optional Model As Long = 0)
    Dim gRect As GRADIENT_RECT
    Dim vert(1) As TRIVERTEX
    Dim Red As Byte, Green As Byte, Blue As Byte
    DecompRGB Color1, Red, Green, Blue
    vert(0).X = X1
    vert(0).Y = Y1
    vert(0).Red = Synchronize(Red)
    vert(0).Green = Synchronize(Green)
    vert(0).Blue = Synchronize(Blue)
    vert(0).Alpha = 0&
    DecompRGB Color2, Red, Green, Blue
    vert(1).X = X2
    vert(1).Y = Y2
    vert(1).Red = Synchronize(Red)
    vert(1).Green = Synchronize(Green)
    vert(1).Blue = Synchronize(Blue)
    vert(1).Alpha = 0&
    gRect.UpperLeft = 0
    gRect.LowerRight = 1
    GradientFillRect hDC, vert(0), 2, gRect, 1, Model
End Sub
